#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		debug_package	%{nil}
%define		majorver	%(echo %{version} | cut -d '.' -f1-2)
%define		minorver	%(echo %{version} | cut -d '.' -f2)
%define		pytname		Python
%define		pylibdir	%{_prefix}/lib/%{name}.%{minorver}
%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')
#-----------------------------------------------------------------------------
Name		:	python3
Version		:	3.12.4
Release		:	17.2.0.rel%{?dist}
Summary		:	Version 3 of the Python programming language aka Python 3000
Group		:	Development/Languages

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Python
URL		:	https://www.python.org/

Source0		:	%{pytname}-%{version}.tar.xz
Source1		:	python-%{version}-docs-html.tar.bz2

#-----------------------------------------------------------------------------
BuildRequires	:	libffi-devel

Requires	:	python3-rpm-macros

Provides	:	python
#-----------------------------------------------------------------------------
%description
Python 3 is a new version of the language that is incompatible with the 2.x
line of releases. The language is mostly the same, but many details, especially
how built-in objects like dictionaries and strings work, have changed
considerably, and a lot of deprecated features have finally been removed.

#-----------------------------------------------------------------------------
%files			
%defattr(-, root,root,-)
%doc LICENSE README.rst
%{_bindir}/2to3
%{_bindir}/2to3-%{majorver}
%{_bindir}/msgfmt.py
%{_bindir}/python
%{_bindir}/python-config
%{_bindir}/pydoc3
%{_bindir}/idle
%{_bindir}/idle3
%{_bindir}/idle%{majorver}
%{_bindir}/pydoc
%{_bindir}/pydoc%{majorver}
%{_bindir}/pygettext.py
%{_bindir}/%{name}*
#{_bindir}/pathfix.py
%{_includedir}/%{name}.%{minorver}/*
%{_libdir}/lib%{name}*.so*
%{_libdir}/pkgconfig/python*.pc
%{pylibdir}/config-%{majorver}-%{_arch}-linux-gnu/*
%{pylibdir}/lib-dynload/*.so
%{pylibdir}/LICENSE.txt
%{pylibdir}/*.py
%{pylibdir}/__pycache__/*.pyc
%{pylibdir}/__phello__/*.py
%{pylibdir}/__phello__/__pycache__/*.pyc
%{pylibdir}/asyncio/*.py
%{pylibdir}/asyncio/__pycache__/*.pyc
%{pylibdir}/collections/*.py
%{pylibdir}/collections/__pycache__/*.pyc
%{pylibdir}/concurrent/*.py
%{pylibdir}/concurrent/__pycache__/*.pyc
%{pylibdir}/concurrent/futures/*.py
%{pylibdir}/concurrent/futures/__pycache__/*.pyc
%{pylibdir}/ctypes/*.py
%{pylibdir}/ctypes/__pycache__/*.pyc
%{pylibdir}/ctypes/macholib/README.ctypes
%{pylibdir}/ctypes/macholib/fetch_macholib*
%{pylibdir}/ctypes/macholib/*.py
%{pylibdir}/ctypes/macholib/__pycache__/*.pyc
%{pylibdir}/curses/*.py
%{pylibdir}/curses/__pycache__/*.pyc
%{pylibdir}/dbm/*.py
%{pylibdir}/dbm/__pycache__/*.pyc
#{pylibdir}/distutils/README
#{pylibdir}/distutils/*.py
#{pylibdir}/distutils/__pycache__/*.pyc
#{pylibdir}/distutils/command/command_template
#{pylibdir}/distutils/command/*.py
#{pylibdir}/distutils/command/__pycache__/*.pyc
#{pylibdir}/distutils/tests/Setup.sample
#{pylibdir}/distutils/tests/*.rst
#{pylibdir}/distutils/tests/xxmodule.c
#{pylibdir}/distutils/tests/*.py
#{pylibdir}/distutils/tests/__pycache__/*.pyc
%{pylibdir}/email/architecture.rst
%{pylibdir}/email/*.py
%{pylibdir}/email/__pycache__/*.pyc
%{pylibdir}/email/mime/*.py
%{pylibdir}/email/mime/__pycache__/*.pyc
%{pylibdir}/encodings/*.py
%{pylibdir}/encodings/__pycache__/*.pyc
%{pylibdir}/ensurepip/*.py
%{pylibdir}/ensurepip/__pycache__/*.pyc
%{pylibdir}/ensurepip/_bundled/*.whl
#{pylibdir}/ensurepip/_bundled/*.py
#{pylibdir}/ensurepip/_bundled/__pycache__/*.pyc
%{pylibdir}/html/*.py
%{pylibdir}/html/__pycache__/*.pyc
%{pylibdir}/http/*.py
%{pylibdir}/http/__pycache__/*.pyc
%{pylibdir}/idlelib/*.txt
%{pylibdir}/idlelib/ChangeLog
%{pylibdir}/idlelib/config*.def
%{pylibdir}/idlelib/help.html
%{pylibdir}/idlelib/idle.bat
%{pylibdir}/idlelib/idle.pyw
%{pylibdir}/idlelib/Icons/README.txt
%{pylibdir}/idlelib/Icons/*.{icns,ico}
%{pylibdir}/idlelib/Icons/*.{gif,png}
%{pylibdir}/idlelib/*.py
%{pylibdir}/idlelib/__pycache__/*.pyc
%{pylibdir}/idlelib/idle_test/README.txt
%{pylibdir}/idlelib/idle_test/*example_noext
%{pylibdir}/idlelib/idle_test/*example_stub.pyi
%{pylibdir}/idlelib/idle_test/*.py
%{pylibdir}/idlelib/idle_test/__pycache__/*.pyc
%{pylibdir}/importlib/*.py
%{pylibdir}/importlib/__pycache__/*.pyc
%{pylibdir}/importlib/metadata/*.py
%{pylibdir}/importlib/metadata/__pycache__/*.pyc
%{pylibdir}/importlib/resources/*.py
%{pylibdir}/importlib/resources/__pycache__/*.pyc
%{pylibdir}/json/*.py
%{pylibdir}/json/__pycache__/*.pyc
%{pylibdir}/lib2to3/Grammar*
%{pylibdir}/lib2to3/PatternGrammar*
%{pylibdir}/lib2to3/*.py
%{pylibdir}/lib2to3/__pycache__/*.pyc
%{pylibdir}/lib2to3/fixes/*.py
%{pylibdir}/lib2to3/fixes/__pycache__/*.pyc
%{pylibdir}/lib2to3/pgen2/*.py
%{pylibdir}/lib2to3/pgen2/__pycache__/*.pyc
#{pylibdir}/lib2to3/tests/*.py
#{pylibdir}/lib2to3/tests/__pycache__/*.pyc
#{pylibdir}/lib2to3/tests/data/*.py
#{pylibdir}/lib2to3/tests/data/README
#{pylibdir}/lib2to3/tests/data/fixers/*.py
#{pylibdir}/lib2to3/tests/data/fixers/myfixes/*.py
%{pylibdir}/logging/*.py
%{pylibdir}/logging/__pycache__/*.pyc
%{pylibdir}/multiprocessing/*.py
%{pylibdir}/multiprocessing/__pycache__/*.pyc
%{pylibdir}/multiprocessing/dummy/*.py
%{pylibdir}/multiprocessing/dummy/__pycache__/*.pyc
%{pylibdir}/pydoc_data/*.py
%{pylibdir}/pydoc_data/__pycache__/*.pyc
%{pylibdir}/pydoc_data/_pydoc.css
%{pylibdir}/re/*.py
%{pylibdir}/re/__pycache__/*.pyc
%{pylibdir}/site-packages/README.txt
%{pylibdir}/sqlite3/*.py
%{pylibdir}/sqlite3/__pycache__/*.pyc
%{pylibdir}/tkinter/*.py
%{pylibdir}/tkinter/__pycache__/*.pyc
%{pylibdir}/tomllib/*.py
%{pylibdir}/tomllib/__pycache__/*.pyc
%{pylibdir}/turtledemo/turtle.cfg
%{pylibdir}/turtledemo/*.py
%{pylibdir}/turtledemo/__pycache__/*.pyc
%{pylibdir}/unittest/*.py
%{pylibdir}/unittest/__pycache__/*.pyc
%{pylibdir}/urllib/*.py
%{pylibdir}/urllib/__pycache__/*.pyc
%{pylibdir}/venv/scripts/*
%{pylibdir}/venv/*.py
%{pylibdir}/venv/__pycache__/*.pyc
%{pylibdir}/wsgiref/*.py
%{pylibdir}/wsgiref/__pycache__/*.pyc
%{pylibdir}/xml/*.py
%{pylibdir}/xml/__pycache__/*.pyc
%{pylibdir}/xml/dom/*.py
%{pylibdir}/xml/dom/__pycache__/*.pyc
%{pylibdir}/xml/etree/*.py
%{pylibdir}/xml/etree/__pycache__/*.pyc
%{pylibdir}/xml/parsers/*.py
%{pylibdir}/xml/parsers/__pycache__/*.pyc
%{pylibdir}/xml/sax/*.py
%{pylibdir}/xml/sax/__pycache__/*.pyc
%{pylibdir}/xmlrpc/*.py
%{pylibdir}/xmlrpc/__pycache__/*.pyc
%{pylibdir}/zipfile/*.py
%{pylibdir}/zipfile/__pycache__/*.pyc
%{pylibdir}/zipfile/_path/*.py
%{pylibdir}/zipfile/_path/__pycache__/*.pyc
%{pylibdir}/zoneinfo/*.py
%{pylibdir}/zoneinfo/__pycache__/*.pyc
%{_defaultdocdir}/%{name}-%{version}/*.html
%{_defaultdocdir}/%{name}-%{version}/objects.inv
%{_defaultdocdir}/%{name}-%{version}/searchindex.js
%{_defaultdocdir}/%{name}-%{version}/_images/*.png
%{_defaultdocdir}/%{name}-%{version}/_downloads/*
%{_defaultdocdir}/%{name}-%{version}/_sources/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/c-api/*.txt
#{_defaultdocdir}/%{name}-%{version}/_sources/distutils/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/distributing/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/extending/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/faq/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/howto/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/install*/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/library/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/reference/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/tutorial/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/using/*.txt
%{_defaultdocdir}/%{name}-%{version}/_sources/whatsnew/*.txt
%{_defaultdocdir}/%{name}-%{version}/_static/*.{css,gif,js,png,xml}
%{_defaultdocdir}/%{name}-%{version}/_static/*.{svg,json}
%{_defaultdocdir}/%{name}-%{version}/c-api/*.html
#{_defaultdocdir}/%{name}-%{version}/distutils/*.html
%{_defaultdocdir}/%{name}-%{version}/distributing/*.html
%{_defaultdocdir}/%{name}-%{version}/extending/*.html
%{_defaultdocdir}/%{name}-%{version}/faq/*.html
%{_defaultdocdir}/%{name}-%{version}/howto/*.html
%{_defaultdocdir}/%{name}-%{version}/install*/*.html
%{_defaultdocdir}/%{name}-%{version}/library/*.html
%{_defaultdocdir}/%{name}-%{version}/reference/*.html
%{_defaultdocdir}/%{name}-%{version}/tutorial/*.html
%{_defaultdocdir}/%{name}-%{version}/using/*.html
%{_defaultdocdir}/%{name}-%{version}/whatsnew/*.html
%{_mandir}/man1/python.1.gz
%{_mandir}/man1/%{name}*.1.gz
#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig

#=============================================================================
%package test
Summary		:	The test modules from the main python package
Group		:	Development/Languages
Requires	:	%{name} = %{version}-%{release}

%description test
The test modules from the main python package: %{name}
These have been removed to save space, as they are never or almost
never used in production.

You might want to install the python-test package if you're developing python
code that uses more than just unittest and/or test_support.py.

#-----------------------------------------------------------------------------
%files test
%{pylibdir}/test/*
#{pylibdir}/ctypes/test/*
#{pylibdir}/sqlite3/test/*.py
#{pylibdir}/sqlite3/test/__pycache__/*.pyc
#{pylibdir}/tkinter/test/*
#{pylibdir}/unittest/test/*

#=============================================================================

%prep
%setup -q -n %{pytname}-%{version}

#-----------------------------------------------------------------------------
#building application
%build

#removing reference to /usr/local/bin/python within
#files to avoid a false dependencies
sed -i							\
  -e '1 s|local/||'					\
	Lib/cgi.py					\

#Note:
#ensurepip=yes to have easy_install/setuptools within
#python3

CXX="/usr/bin/g++" 					\
./configure						\
        --prefix=%{_prefix}				\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-ipv6					\
	--enable-shared					\
	--with-system-expat				\
	--with-system-ffi				\
	--with-ensurepip=no				\

#if you want python3 to auto-check add
#	--enable-optimizations				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}					\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}								\
	DESTDIR=%{buildroot}						\
	install

# Install pathfix.py to bindir
# See https://github.com/fedora-python/python-rpm-porting/issues/24
#%{__cp} -p								\
#	Tools/scripts/pathfix.py					\
#	%{buildroot}%{_bindir}/
	
 
#export VIRTUAL_ENV=%{_prefix}
#python3 -m venv							\
#	%{buildroot}%{_prefix}

install -dm755 %{buildroot}%{_defaultdocdir}/%{name}-%{version}
%{__tar}								\
	--strip-components=1						\
	--no-same-owner							\
	--directory %{buildroot}%{_defaultdocdir}/%{name}-%{version}	\
	-xf								\
	 %{SOURCE1}

# https://fedoraproject.org/wiki/Changes/Python_means_Python3
%{__ln_s}								\
	./python3							\
	%{buildroot}%{_bindir}/python
%{__ln_s}								\
	./pydoc3							\
	%{buildroot}%{_bindir}/pydoc
%{__ln_s}								\
	./pygettext3.py							\
	%{buildroot}%{_bindir}/pygettext.py
%{__ln_s}								\
	./msgfmt3.py							\
	%{buildroot}%{_bindir}/msgfmt.py
%{__ln_s}								\
	./idle3								\
	%{buildroot}%{_bindir}/idle
%{__ln_s}								\
	./python3-config						\
	%{buildroot}%{_bindir}/python-config
%{__ln_s}								\
	./python3.1							\
	%{buildroot}%{_mandir}/man1/python.1
%{__ln_s}								\
	./python3.pc							\
	%{buildroot}%{_libdir}/pkgconfig/python.pc

%{__rm} -f								\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/.buildinfo

# Fixup permissions for shared libraries from non-standard 555 to standard 755:
#find %{buildroot}					\
#	-perm 555					\
#	-exec chmod 755					\
#	{} \;


#-----------------------------------------------------------------------------
%changelog
